package sun.awt.windows;

import java.io.IOException;
import java.io.InputStream;

final class WDropTargetContextPeerIStream extends InputStream
{
    private long istream;
    
    WDropTargetContextPeerIStream(long istream) throws IOException {
        if (istream == 0L) {
            throw new IOException("No IStream");
        }
        this.istream = istream;
        return;
    }
    
    @Override
    public int available() throws IOException {
        if (this.istream == 0L) {
            throw new IOException("No IStream");
        }
        return this.Available(this.istream);
    }
    
    private native int Available(long p0);
    
    @Override
    public int read() throws IOException {
        if (this.istream == 0L) {
            throw new IOException("No IStream");
        }
        return this.Read(this.istream);
    }
    
    private native int Read(long p0) throws IOException;
    
    @Override
    public int read(byte[] array, int n, int n2) throws IOException {
        if (this.istream == 0L) {
            throw new IOException("No IStream");
        }
        return this.ReadBytes(this.istream, array, n, n2);
    }
    
    private native int ReadBytes(long p0, byte[] p1, int p2, int p3) throws IOException;
    
    @Override
    public void close() throws IOException {
        if (this.istream != 0L) {
            super.close();
            this.Close(this.istream);
            this.istream = 0L;
        }
    }
    
    private native void Close(long p0);
}
